#ifndef DIRENT_H
#define DIRENT_H

#include "includes.h"
#include "sizes.h"

/* description of a direntry including d64 specific values*/
typedef struct dirent64 {
    /* start position of file */
    uint8_t d_track;
    uint8_t d_sector;
    /* track/sector and offset of where the dirent is stored */
    uint8_t d_detrack;
    uint8_t d_desector;
    uint8_t d_desectpos;
    /* size information */
    uint16_t d_blocks;
    size_t d_size;

    uint8_t d_type;    /* DEL, SEQ, PRG, USR, REL, DIR */
    uint8_t d_locked;    //Bit 6
    uint8_t d_closed;    //Bit 7 produces * if not set
    uint8_t d_ctype;
    char d_petscii_name[MAX_C64_NAME + 1];
    char d_ufs_name[MAX_FILESPEC + 1];
} dirent64;

#endif /* DIRENT_H */
