#ifndef FILE_FUNCS_H
#define FILE_FUNCS_H

#include "includes.h"
#include "file.h"

//I/O funcs
int file_read(file64*, uint8_t*);
int file_write(file64*, uint8_t);
int file_write_filespec(file64*, uint8_t);

//open/close funcs
int file_close(file64*);
int file_open(file64*);

//file operation funcs
int file_delete(file64*);
int file_rename(file64*, char*);
int file_copy(file64*, char*);

int file_setup_from_dirent(file64*, dirent64*);

//add filespec als parameter für open, close, scratch, create, rename, findfirst

int file_search(file64*, uint8_t);
file64* file_create();
void file_init(file64*);
void file_destruct(file64*);

#endif /* FILE_FUNCS_H */
