;TODO
;
;to avoid piggypacking:
;request x bytes -> 64net
;c64 <- 0 bytes/1 byte
;if (!data) -> $80;
;if (inlen) read data, dec inlen
;if (!inlen) -> status -> 64net
;<- $02 / $40
;if (!status) -> $80;

;command -> 64net;
;if (!ack) -> $80

* = $e000
!bin "c64/kernal.orig"

;place those two counters on the stack yet, far away from the stuff the RR writes there too.
;outlen   = $170
inlen    = $a5 ; $a5
;für inlen aber ggf $a4 ausreichend zum tainten? da inlen ja bei geholtem packet gesetzt/resettet wird) nach fertigem laden dann wieder frei

;outlen = regl - 1
;inlen = regl/regh - header - 1
;s0_rx_rd reg: zeigt inlen -> if regh & 0x7 eor rx_rd_high == 0 && regl eor rx_rd_low == 0 -> last byte -> S0_CR -> received flaggen damit pointer advanced

savepos  = $170 ;95
loadpos  = $a4 ;a4

;address of 64net
device   = $09

;i/o registers
clockpe  = $de01
base     = $de02
;A1 is already set by the base-adr, thus A1 appears inverted, aechz.
;de02 = A0:0 A1:1 A2:0 -> but that would already select reg2 from wiznet

rmode    = base + 2 ; de04
regh     = base + 3 ; de05
regl     = base + 4 ; de06
data     = base + 5 ; de07

;wiznet registers
wconfig  = $0001 ;config registers

ir       = $0015 ;interrupt register
irmask   = $0016 ;interrupt mask register

s0mr     = $0400 ;mode reg
s0cr     = $0401 ;command reg
s0ir     = $0402 ;irq reg
s0sr     = $0403 ;status reg
s0port   = $0404 ;source port

s0dipr   = $040c ;dest ip
s0dport  = $0410 ;dest port

s0txfsr  = $0420 ;tx free size
s0txrr   = $0422 ;tx read pointer
s0txwr   = $0424 ;tx write pointer

s0txbase = $4000 ;addr of tx buf
s0txmask = $47ff ;mask for tx buf

s0rxbase = $6000 ;addr of rx buf
s0rxmask = $67ff ;mask for rx buf

s0rxrsr  = $0426 ;rx rcv size
s0rxrd   = $0428 ;rx read pointer

;manipulated kernal-message
* = $e49b  ;-$e4c0
kernalmsg
         !convtab pet
         !text "64net/3 system"

;hook-up for reset
* = $fce7
reset
         jsr init

;hook-up for serin
* = $ee13
serin
         jmp fserin

;hook-up for serout
* = $ed41
serout
         jmp fserout

;remove nmi handler for rs-232
* = $ed0e
nonmi
         ;wipe out jsr to nmi check/blocker for rs232
         ;as this routine is used for rs232 only, we might overwrite that segment with our stuff
         nop
         nop
         nop

;hook-up for serout under atn
* = $ed24
soutatn
         jmp fsoutatn

;hook-up for listener-shift
* = $edcd
shiftli
         jmp fshiftli

;hook-up for listen SA
* = $edbb
salisten
         jmp fsalisten

;hook-up for talk SA
* = $edc9
satalk
         jmp fsatalk

;hook-up for untalk
* = $edf0
untalk
         jmp funtalk

;hook-up for unlisten
* = $ee03
unlisten
         jmp funlisten

;hook-up on load-vector
* = $f4a2
loadvec
         jmp floadvec

;branch for own loader
* = $f4d5
load
         jmp fload

;hook-up on save-vector
* = $f5ea
savevec
         jmp fsavevec

;branch for own saver
* = $f61c
save
         jmp fsave

;funktion block 1
* = $eebb ;-$f0a3
;make it cheap (fast) and easy, actually any device >= 9 will be selected as 64net-device
is64net
         pha
         lda $ba
         cmp #device
         ;anything >= device is 64net
         bcs yep
         clc
yep
         pla
myrts
         rts

;fork all calls depending if 64net is adressed or not
fshiftli
         jsr is64net
         bcc *+5
         jmp shiftli+11
         jsr $eea0
         jmp shiftli+3
fsoutatn
         jsr is64net
         bcs command
         jsr $ee97
         jmp soutatn+3
fsalisten
         jsr is64net
         bcs command
         jsr $ed36
         jmp salisten+3
fsatalk
         jsr is64net
         bcs command
         jsr $ed36
         jmp satalk+3
funlisten
         jsr is64net
         ;nothing to do here
         bcs myrts
         jsr $edbe
         jmp unlisten+3
funtalk
         jsr is64net
         bcs myuntalk
         jsr $ee8e
         jmp untalk+3
myuntalk
         ;skip some unnecessary stuff
         jmp $edfb
;send a command via 64net
command
         ;unblock interrupts again (blocked by original serout)
         cli
         ;remaining outgoing bytes?
         lda regh
         and #$60
         cmp #$40
         bne noflush
;         and #$f0
;         cmp #$60
;         bne noflush
;         ;if so, send bytes from buffer
;         inc $0400
         jsr sendpkt
noflush
         ;send byte from $95 as command packet
         lda $95
;         sta $0402
         jmp sendcmd
fserin
         jsr is64net
         bcs myserin
         sei
         lda #$00
         jmp serin+3
myserin
         cli
         ;still bytes to read?
;         lda regh
;         and #$60
;         cmp #$60
;         beq normsi
         lda inlen
         bne normsi
         ;nope, get a new packet
         lda #$00
         jsr request
         bne endsi
normsi
         ;XXX speed up by dec inlen first then lda data -> sta $a4 clc rts || lda data sta$a4, lda data sta$90, lda $a4, clc rts
         ;normal operation, read byte from buffer
         ;count down
         dec inlen
         ;last byte from packet?
         bne endsi
         ;yes, so read status as well
         ;XXX TODO encasplue this into a separate status request!?
         lda data
         sta $a4
         lda data
         sta $90
         ;last byte of packet received, set datapointer outside of range to flag new request
         ;lda #$00
         ;sta regh
         lda $a4
         clc
         rts
endsi
         lda data
         sta $a4
         clc
         rts
fserout
         jsr is64net
         bcs myserout
         jsr $ee97
         jmp serout+3
sendbyte
myserout
         cli
         ;is regh/l already set to tx-buffer?
         bit regh
         bvs dosend
;         lda outlen
;         bne dosend
         ;no, so set up things for a new data packet
         jsr startdata
dosend
         ;put byte into buffer
         lda $95
         sta data
         ;increment counter
         lda regl
         cmp #$02
         bne sende
         lda regh
         cmp #$41
         bne sende
;         inc outlen
;         bne sende
         ;last byte, now send packet
;         lda #$00
         jsr sendpkt
sende
         ;restore A
         ;lda $95
         clc
         rts

         ;load/save

floadvec
         jsr is64net
         bcs myloadvec
         jmp ($0330)
myloadvec
         jmp loadvec+3
fload
         jsr is64net
         bcs myload
         jsr $ee13
         jmp load+3
myload
         ;request 2 bytes first (start-address)
         lda #$02
         jsr request
         lda data
         sta $ae
         ;still bytes left?
         dec inlen
         ;oops, already last byte, so fetch error
         bne loadc
         ;check for error
         lda data
         sta $90
         bit $90
         ;eof already, seems we loaded a dir
         bvs dirl
         ;all fine
         beq loadc
         lsr
         lsr
         ;print error message
         jmp $f704
loadc
         ;continue with highbyte
         lda data
         sta $af
         txa
         bne noaeset
         ;will load-address be overwritten?
         lda $c3
         sta $ae
         lda $c4
         sta $af
noaeset
         ;print LOADING
         jsr $f5d2
         ;print start-address
         jsr hexout
         sei
         ;copy loader to stack area
         jsr copyload
loop2
         ;request $100 byte blocks now
         lda #$00
         jsr request
         ;all sane ($90)?
         bne endel
         lda inlen
         sta loadpos
         ;perfect, we can transfer a full block
         beq loadok
         ;partial block, so do a loadpos = 0-loadpos to get the num of bytes missing from a full block
         lda #$00
         sec
         sbc loadpos
         sta loadpos
         ;subtract difference from current address. Now we can count loadpos up to $100 as if it
         ;would be a fullblock transfer, just with loadpos having another value then 0 preloaded
         lda $ae
         sec
         sbc loadpos
         sta $ae
         lda $af
         sbc #$00
         sta $af
loadok
         ;transfer block
         jsr $0100
         ;count up
         inc $af
         ;check piggypacked status
         lda data
         sta $90
         beq loop2
endel
         ;print end-address
         jsr hexout
         ;end of transfer
         lda #$00
         sta inlen
loadcl
         cli
         ;close
         jmp $f528
dirl
         jmp dirout
fsavevec
         jsr is64net
         bcs mysavevec
         jmp ($0332)
mysavevec
         jmp savevec+3
fsave
         jsr is64net
         bcs mysave
         jsr $eddd
         jmp save+3
mysave
         ;start with a data packet header
         jsr startdata
         lda $ac
         sta data
         lda $ad
         sta data
;         lda #$02
         ;send out data packet
         jsr sendpkt
         sei
         jsr copysave
savel
         lda $ae
         sec
         sbc $ac
         sta savepos  ;save lowbyte
         lda $af
         sbc $ad
         bne sfull   ;>0, send full
         lda savepos  ;even savepos is 0?
         beq endes   ;so end saving
         ;we send a partial block (<$100)
         lda #$00    ;do a 0-savepos
         sec
         sbc savepos
         sta savepos  ;subtract from $ac/$ad
         lda $ac
         sec
         sbc savepos
         sta $ac
         lda $ad
         sbc #$00
         sta $ad
         jmp saveok
sfull
         lda #$00
         sta savepos
saveok
         jsr startdata
         jsr $0100
         ;flip savepos again to have right amount to send
;         lda #$00
;         sec
;         sbc savepos
         jsr sendpkt
         inc $ad
         jmp savel
endes
         cli
         jmp $f63f

;function block 2
;wiznet-funcs

* = $f72c ;-$fcbc
init
         lda clockpe
         eor #$01
         sta clockpe
         ldy #$00
         ldx #$00
;         stx inlen
;         stx outlen
loopi1
         lda regl
         cmp regl
         beq skip1
         inx
         bne loopi1
         beq failed
skip1
         iny
         bne loopi1
active
         jsr wizinit
         jmp $fd02
failed
         stx $d020
         lda clockpe
         and #$fe
         sta clockpe
         jmp $fd02

startdata
         ;set up things for sending
         jsr udpsetsend
         ;D = data packet
         lda #$44
         sta data
         ;return to fill up data first
         rts
sendcmd
         pha
         ;set up things for sending
         jsr udpsetsend
         ;C = command packet
         lda #$43
         sta data
         pla
         ;command value
         sta data
         ;payload = 1
;         lda #$01
         jmp sendpkt
request
         pha
         ;set up things for sending
         jsr udpsetsend
         ;R = request packet
         lda #$52
         sta data
         ;requested ammount lowbyte
         pla
         sta data
         beq xxxx    ;set highbyte to $01
         lda #$01    ;will result in $00 for highbyte
xxxx
         eor #$01
         ;highbyte
         sta data
         ;finalize send, payload = 2
;         lda #$02
         ;jmp sendpkt
sendpkt
         jsr udpsend
         ;jmp receive
receive
         ;receive a packet
         jsr udprcv
         ;we had any errors?
         lda $90
         beq rcvcont
         sec
         rts
rcvcont
         ;all sane
         lda data
         cmp #$45
         ;an error packet
         beq errormsg
         cmp #$44
         ;a data packet
         beq endrcv
         ;nothing of use
         ;reinit socket and start over again
;         inc $0403
         jsr udpclose
         jsr udpopen
         jmp receive
errormsg
         ;receive status, though maybe not necessary
         lda data
         sta $90
;         lda #$00
;         sta regh
endrcv
         lda $90
endrcv2
         clc
         rts
dirout
         ldx #$00
dirout2
         lda chdir,x
         jsr $ffd2;
         inx
         cpx #$0c
         bne dirout2
         cli
         jmp endrcv2
chdir
         !byte $0d
         !convtab pet
         !text "changed dir"
hexout
         lda #$9d
         bmi *+3
         rts
         lda #$20
         jsr $ffd2
         lda #$24
         jsr $ffd2
         lda $af
         jsr dohex
         lda $ae
dohex
         pha
         lsr
         lsr
         lsr
         lsr
         jsr single
         pla
single
         and #$0f
         cmp #$0a
         bcc x1
         adc #$66
x1
         eor #$30
         jmp $ffd2

         ;turn autoinc on
aincon
         pha
         lda rmode
         ora #$02
         bne setm

         ;turn autoinc off
aincoff
         pha
         lda rmode
         and #$fd
setm
         sta rmode
         pla
         rts

         ;write reg $XXYY
wreg
         jsr setreg
         sta data
         rts

         ;read reg $XXYY
rreg
         jsr setreg
         lda data
         rts
setreg
         stx regl
         sty regh
         rts
config
gateway
         !byte 192,168,1,1
netmask
         !byte 255,255,0,0
mac
         !byte $00,$00,$00,$64,$64,$68
addr
         !byte 192,168,2,68
destip
         !byte 192,168,2,13
destport
         !byte $13,$89

         ;XXX wait send-ok (s0ir) +
         ;test cr == 00 hier machen!!!
         ;-> keine zeit wird mit warten
         ;vergeudet
udpopen
         ;save registers
         pha
         txa
         pha
         tya
         pha
         ;set udp mode
         ldy #>s0mr
         ldx #<s0mr
         lda #$02
         jsr wreg

         ;set sourceport $1389 = 5001
         ldx #<s0port
         lda #$13
         jsr wreg
         inx
         lda #$89
         jsr wreg

         ;send open command
         ldx #<s0cr
         lda #$01
         jsr wreg
         ;wait until processed
         jsr rreg
         bne *-3
         ;restore registers
         pla
         tay
         pla
         tax
         pla
         rts
udpclose
         ;save registers
         pha
         txa
         pha
         tya
         pha
         ;turn of autoincrement
         jsr aincoff
         ;send close command
         ldy #>s0cr
         ldx #<s0cr
         lda #$10
         jsr wreg
         ;restore registers
         pla
         tay
         pla
         tax
         pla
         rts
udprcv
         ;save X/Y
         txa
         pha
         tya
         pha
         ;reset status and inlen
         lda #$00
         sta $90
         sta inlen
waitrcv
         ;check interrupt register
         ldy #>ir
         ldx #<ir
         jsr rreg
         ;destination unreachable?
         and #$40
         ;all okay, continue
         beq getgo
         ;error occurred
         ;clear bit
         jsr wreg
         ;set error
;         inc $0401
         lda #$80
         sta $90
         ;end end
         bne udpgetx
getgo
         ;check socket interrupt register
         ldy #>s0ir
         ldx #<s0ir
         jsr rreg
         and #$04
         ;nothing to do, start over again
         beq waitrcv
         ;got something
         ;clear flag by writing back
         jsr wreg

         ;read size register
         ldx #<s0rxrsr
         jsr rreg
         inx
         jsr rreg
         sec
         ;subtract overhead
         sbc #$0a   ;8 byte header, 1 byte packettype, 1 byte status (in case)
         ;and store payload length
         sta inlen

         ;XXX TODO check for correct sender ip/port

         ;set read pos @ base + 8 to the start of packet (not payload!)
         lda #>s0rxbase
         sta regh
         lda #$08
         sta regl

         ;turn on autoincrement
         jsr aincon
udpgetx
         ;restore X/Y
         pla
         tay
         pla
         tax
         rts

udpsetsend
         ;save registers
         pha
         txa
         pha
         tya
         pha
         ;close socket, if open at all
         jsr udpclose
         ;open a shiny new socket
         jsr udpopen

         ;set destip, port (6 bytes) by copying from config block ...
         ldy #>s0dipr
         ldx #<s0dipr
loop3
         lda destip - <s0dipr,x
         jsr wreg
         inx
         cpx #<s0dipr+$06
         bne loop3

         ;set buffer base pos
         lda #>s0txbase
         sta regh
         lda #<s0txbase
         sta regl

         ;turn on autoincrement
         jsr aincon

         ;restore registers
         pla
         tay
         pla
         tax
         pla
         rts

;packet_present (either in or out shoudl work ($4xxx || $6xxx)
;         bit regh
;         bvs present;
;more precisely: check for $40 or $60 -> present_out/in


;inlen
;         rxrsr (packet erst beio close quitieren)
;         -> rxrsr - ((datapointer & 0x7ff) - $a) == inlen
; alternativ: rxrsr mit datapointer & 0x7ff - $0a vergleichen, falsl gleich, ende

;udpsend_alt
;         ;store payload size
;         sta outlen
;         ;save registers
;         pha
;         txa
;         pha
;         tya
;         pha
;         ;add 1 (packet type) to payload len and respect that a len of 0 means $100 bytes
;         lda outlen
;         clc
;         adc #$01
;         ldy #>s0txwr
;         ldx #<s0txwr+1
;         jsr wreg
;         lda outlen
;         bne noinc2
;         ;force increment if outlen == 0
;         sec
;noinc2
;         lda #$00
;         adc #$00
;         dex
;         ;highbyte of size;
;         jsr wreg

udpsend
         ;save registers
         pha
         txa
         pha
         tya
         pha
         ;put data pointer (&0x7ff) to stack
         lda regl
         pha
         lda regh
         and #$07
         pha
         ;set payload
         ldy #>s0txwr
         ldx #<s0txwr
         pla
         jsr wreg
         inx
         pla
         jsr wreg

         ;stop autoincrement
         jsr aincoff

         ;submit send command
         ldx #<s0cr
         lda #$20
         jsr wreg
         ;wait until command is precessed
         jsr rreg
         bne *-3

         ;wait until finished
         ldx #<s0ir
waits2
         jsr rreg
         and #$10
         beq waits2
         ;ack irq
         jsr wreg

         ;reset outlen
;         lda #$00
;         sta outlen
         ;restore registers
         pla
         tay
         pla
         tax
         pla
         rts
wizinit
         ;reset
         lda #$80
         sta rmode
         ;wait until reset cycle is finished
         lda rmode
         bne *-3
         ;set indirect if mode
         lda #$01
         sta rmode

         ;copy config to registers
         ;start at $0001
         ldx #<wconfig
         ldy #>wconfig
conf01
         lda config - <wconfig,x
         jsr wreg
         inx
         cpx #$12 + <wconfig
         bne conf01
         ;assign 4k for socket 0 + 1
         ;socket 2 + 3 unused
         ldy #$00
         ldx #$1a
         lda #$aa
         jsr wreg
         inx
         jsr wreg

         ;disable all irqs, so we don't get nmi's thrown
         ldx #<irmask
         lda #$00
         jsr wreg
         rts

;function block 3, copyload/copysave
* = $f409 ;-$f482

copyload
         ;copy fastloader to stack
         ldx #loade-loads
         lda loads,x
         sta $0100,x
         dex
         bpl copyload+2
         rts

loads
         ldy loadpos
         lda $ae
         sta a1 - loads + $0100 + 1
         sta a2 - loads + $0100 + 1
         lda $af
         sta a1 - loads + $0100 + 2
         sta a2 - loads + $0100 + 2
         ;start to write under rom from $d000 on (rest is write through)
         ;XXX TODO could be more precicely from $d000-$e000
         cmp #$cf   ;coz $100 bytes!
         bcs rom
normal
rcv
         ;copy $100-y bytes from buffer to RAM
         lda data
a1       sta $1000,y
;         sta ($ae),y
         iny
         bne rcv
         rts
rom
         lda $01
         pha
         ldx #$34
rcvr
         lda data
         stx $01
a2       sta $1000,y
;         sta ($ae),y
         lda #$35
         sta $01
         iny
         bne rcvr
         pla
         sta $01
         rts
loade

copysave
         ldx #savee-saves
         lda saves,x
         sta $0100,x
         dex
         bpl copysave+2
         rts

saves
         ldy savepos
;         lda $ac
;         sta b1 - saves + 1 + $0100
;         sta b2 - saves + 1 + $0100
         lda $ad
;         sta b1 - saves + 2 + $0100
;         sta b2 - saves + 2 + $0100
         ;start to read under rom from $a000 on
         cmp #$9f   ;coz $100 bytes!
         bcs roms
normals
snd
         ;copy $100-y bytes from RAM to buffer
;b1       lda $1000,y
         lda ($ac),y
         sta data
         iny
         bne snd
         rts
roms
         lda $01
         pha
         ldx #$35
sndr
         lda #$34
         sta $01
;b2       lda $1000,y
         lda($ac),y
         stx $01
         sta data
         iny
         bne sndr
         pla
         sta $01
         rts
savee

