#ifndef NETWORK_H
#define NETWORK_H

#include "includes.h"
#include "sizes.h"
#include "macros.h"

typedef struct packet64 {
    uint8_t data[MAX_MTU];
    uint8_t type;
    uint8_t err;
    uint8_t command;
    unsigned int req_size;
    unsigned int size;
    unsigned int ack_bytes;
} packet64;

#define PACKET_NONE                0x00
#define PACKET_DATA                0x44
#define PACKET_COMMAND             0x43
#define PACKET_ERROR               0x45
#define PACKET_REQUEST             0x52

#endif /* NETWORK_H */
