#include "string.h"
#include "string_funcs.h"
#include "debug_funcs.h"

void dyn_strncpy(char** target, char* source, size_t num) {
    int size = 1;
    if(source) size += num;
    //XXX handle if sourcelen < num
    if(!*target || strlen(*target) != size) {
        *target = realloc(*target, size * sizeof(char));
    }
    memset(*target, 0, size * sizeof(char));
    if(source && num) {
        strncpy(*target, source, num);
    }
}

void dyn_strcpy(char** target, char* source) {
    int size = 1;
    if(source) size += strlen(source);
    if(!*target || strlen(*target) != size) {
        *target = realloc(*target, size * sizeof(char));
    }
    memset(*target, 0, size * sizeof(char));
    if(source && strlen(source)) {
        strcpy(*target, source);
    }
}

void dyn_strcat(char** target, char* source) {
    int tsize = 0;
    int ssize = 0;

    /* init target in case */
    if(!*target) {
        *target = calloc(1, sizeof(char));
    }

    tsize = strlen(*target);
    if(source) {
        ssize += strlen(source);
        *target = realloc(*target, (ssize + tsize + 1) * sizeof(char));
        memset(*target + tsize, 0, (ssize + 1) * sizeof(char));
        strcat(*target, source);
    }
}

void dyn_strinit(char** str) {
    str = calloc(1, sizeof(char));
}

void dyn_strfree(char* str) {
    if(str) free(str);
    str = NULL;
}
